function f = model1(x,data,betta,delta,p,T,W)

% parameters to be estimated
gamma = x(1);
alpha = x(2);

% the g-function
for t = 1:T-1
    g(t,1) = data(1,t)-(1/gamma)*(betta*(alpha*data(3,t+1) + p*(1-delta)...
               + (gamma/2)*data(1,t+1)^2 + gamma*(1-delta)*data(1,t+1)) - p);
end

% the instruments z
A = data(2,1:T-1)';  % lagged productivity
PI = data(3,1:T-1)'; % lagged profit rate

% the vector of orthogonality conditions (a 1x2) vector here
m = 1/T*g'*[A PI];            

% the function you want to maximize
f = m*W*m';