function f = model1_exa2(x,data,betta,p,TT,WW)

% parameters to be estimated
gamma = x(1);
alpha = x(2);
delta = x(3);
 
% the g-function
for t = 2:TT-2
    g(t,1) = data(1,t)-(1/gamma)*(betta*(alpha*data(3,t+1) + p*(1-delta)...
               + (gamma/2)*data(1,t+1)^2 + gamma*(1-delta)*data(1,t+1)) - p);
end

% the instruments z
% current values
A = data(2,2:TT-1)';
PI = data(3,2:TT-1)';
% lagged values
Alag = data(2,1:TT-2)';
PIlag = data(3,1:TT-2)';

% the orthogonality condition
m = 1/TT*g'*[A PI Alag PIlag];            
% the function you want to maximize
f = m*WW*m';