function W=vcovHAC(m,prewhite)
[T,k]=size(m);
% prewithening
aa=zeros(k,k);
if(prewhite > 0)
    mm=m(1:T-1,:);
    ym=m(2:T,:);
    aa=((mm'*mm)\eye(k))*mm'*ym;
    var_fit=ym-mm*aa;
end
% bartlett
ca=2/3;
%ST=1.1447*(alfa(1)*T)^(1/3);
ST=T^(1/3);
% initialize 
tempJT=zeros(k,k);
j=0;
for j=0:(T-1)
    if 1-abs(ca*j/ST)>0
        gamma_j=zeros(k,k);
        if j==0
            for t=(j+1):T
                gamma_j=gamma_j+m(t,:)'*m(t,:);
            end
        tempJT=tempJT+(1-abs(ca*j/ST))*(gamma_j)./T;
        elseif j>=1
            for t=(j+1):T
                gamma_j=gamma_j+m(t,:)'*m(t-j,:);
            end
        tempJT=tempJT+(1-abs(ca*j/ST))*(gamma_j+gamma_j')./T;
        end
    end
end
tempJT=(T/(T-k*k))*tempJT;
%W=((eye(k)-aa)\eye(k))*tempJT*((eye(k)-aa)\eye(k))';
W=((mm'*mm)\eye(k))*tempJT*((mm'*mm)\eye(k))';